c**********************************************************************
c
c                       =========================
c                          subroutine DLM0    
c                       =========================
c                                                             l
c       Calculate the reduced Wigner rotation matrix element d   (beta).
c                                                             m,0
c
c       written by ZL 28-Feb-95
c
c       Includes:
c               rndoff.inc
c               pidef.inc
c
c       Uses:
c
c**********************************************************************
c
      subroutine dlm0(dlm,l,m,beta)
c
      include 'pidef.inc'
      include 'rndoff.inc'
c
      integer l,m
      double precision beta,dlm
      double precision fct0,z
c
      double precision fact
      external fact
c
c######################################################################
c
      if(dabs(beta-90.0d0).lt.rndoff.or.
     #   dabs(beta-270.0d0).lt.rndoff) then
        z=0.0d0
      else 
        z=dcos(beta*pi/180.0d0)	
      end if
c
      fct0=fact(l-m)-fact(l+m)
      fct0=dexp(fct0/2.0d0)
c
      dlm=fct0*plgndr(l,m,z)
c      
      return
      end


c       VERSION 1.0     12/17/88
c*********************************************************************
c
c                         FUNCTION FACT
c                         =============
c
c        This real function function returns the logarithm
c        of the factorial of the argument n (0 if n<=0)
c
c*********************************************************************
c
      double precision function fact(n)
c
      integer n,i
c
      double precision zero
      parameter (zero=0.d0)
c
c#####################################################################
c
      if (n.le.1) then
         fact=zero
      else
         fact=zero
         do i=2,n
            fact=fact+dlog(dble(i))
         end do
      end if
c
      return
      end

