c Based on EPRCGL - Version 1.4  4/13/93
c*********************************************************************
c
c                          ================
c                          PROGRAM : EPRCGS
c                          ================
c                    *** Pruned basis version ***
c
c       This program does the EPR spectral calculation using the
c       complex symmetric conjugate gradients algorithm and the 
c       reconstruction of the "Lanczos" tridiagonal matrix, in
c       the presence of a rotating SRLS.
c
c       written  by DJS 24-OCT-87
c       modified by DEB 13-MAR-92 to allow longer filenames
c                       22-OCT-92 Handles case of version incompatibility
c       modified by AP  17-FEB-94 for EPRSR calculation
c
c       Includes :
c               stddim.inc
c               stdio.inc
c               eprmat.inc
c               eprdat.inc
c               fnames.inc
c               timer.inc (UNIX-specific timing with dtime function)
c
c       Uses :
c               getids.f
c               setnam.f
c               rddat.f
c               wrdat.f
c               matrll.f
c               stvect.f
c               cscg.f
c
c*********************************************************************
c
      program litjcgs
c
      implicit none
c
      include 'stddim.inc'
      include 'stdio.inc'
      include 'eprdat.inc'
      include 'eprmat.inc'
      include 'fnames.inc'
      include 'timer.inc'
      include 'rndoff.inc'
      include 'pidef.inc'
c
      integer kk0,kk0a1,kk0a2,kk0a(2,3)
      integer jk2,jk2mn,jk2sp
      double precision zero,vnorm,ckk0(3),s(5)
      parameter (zero=0.0D0)
c
      logical fexist
c
      double precision x(2,mxdim),y(2,mxdim),alpha(2,mxstep),
     #                 beta(2,mxstep)
c
      integer i,j,nfiles,ncalc,ierr,ndone,ii,kk0max
      integer mxc20,mxc22,istep,ict,nct
      double precision error,rndoff1
      character*1 chr1,chr2
c
      integer npts,nstepl,ideriv,ndiag,isort
c
      double precision db,bsweep,tr,ti,two
      parameter (two=2.0D0)
      double precision field(mxpt),spect(2,mxpt),
     #       field0(mxpt),spect0(2,50*mxpt),spect1(2,50*mxpt),
     #       temp1(2,mxstep),temp2(2,mxstep),w(2,mxstep)
c
      double precision taum,tauc,tau,orpr,sd1,sd2,sd3,one,c(5)
      parameter(one=1.0D0)

c     double precision order
c     external order
c
c#####################################################################
c
c........................................
c Timing call specific to UNIX systems
c     cputot = dtime( tarray )
c........................................
c
      write (luttyo,1000)
      write (luttyo,1010)
c
      call getids(nfiles,mxcalc)
      if (nfiles.eq.0) goto 9999
c
c======================================================================
c     loop over calculations
c======================================================================
c
      do 100 ncalc=1,nfiles
c
        fileid = files(ncalc)
c
c---------------------------------------------------------------------
c     construct file names
c---------------------------------------------------------------------
c
        call setnam
        call setflg( flags(ncalc) )
c
c----------------------------------------------------------------------
c     open log file and write out header  
c----------------------------------------------------------------------
c
	open (unit=lulog,file=rlname(:namlth),access='sequential',
     #        status='unknown',form='formatted')
	rewind (unit=lulog)
c
        write (luttyo,1000)
	write (lulog,1000)
        write (luttyo,5000) ncalc,prname(:namlth)
    	write (lulog,5000) ncalc,prname(:namlth)
c
c----------------------------------------------------------------------
c     read in parameters from matrix
c----------------------------------------------------------------------
c
	inquire(file=prname(:namlth),exist=fexist)
c
	if (fexist) then 
          call rddat(prname,namlth,ierr)
          if (ierr.eq.-100) then
            write (luttyo,1201) prname(:namlth)
            write (lulog,1201) prname(:namlth)
            go to 110
          else if (ierr.ne.0) then
            write (luttyo,1200) prname(:namlth)
            write (lulog,1200) prname(:namlth)
            go to 110
          end if
        else
	  write (luttyo,1100) prname(:namlth)
          write (lulog,1100) prname(:namlth)
          go to 110
        endif
c
c----------------------------------------------------------------------
c     check to make sure that CG calculation desired
c----------------------------------------------------------------------
c
        if (itype.ne.1) then
          write (luttyo,5100) prname(:namlth)
          write (lulog,5100)  prname(:namlth)
          go to 110
        end if
c
c---------------------------------------------------------------------
c    print out input parameter set
c---------------------------------------------------------------------
c		
	call wrparm(prname,namlth,lulog)
c
c----------------------------------------------------------------------
c      Determine basis set indices (0: read .ind file if present)
c----------------------------------------------------------------------
c
        call lbasix( ixname,namlth,0 )
c
c---------------------------------------------------------------------
c     calculate d20k
c---------------------------------------------------------------------
c
        npts=512
c
c--------begin loop over kk0----------------------
c
        do i=1,npts
          spect(1,i)=zero
          spect(2,i)=zero
        enddo
c
        kk0a(1,1)=kk01
        kk0a(2,1)=0
        kk0a(1,2)=kk02
        kk0a(2,2)=0
        kk0a(1,3)=kk01
        kk0a(2,3)=kk02
c
        if (kk01.eq.kk02) then
          kk0max=1
          ckk0(1)=1.0D0
        else
          kk0max=3
          ckk0(1)=-0.5D0
          ckk0(2)=-0.5D0
          ckk0(3)=0.5D0
        endif
c 
        do ii=1,kk0max
c       do ii=1,1
          kk0a1=kk0a(1,ii) 
          kk0a2=kk0a(2,ii) 
c
          write(*,*),'kk0a1,kk0a2=',kk0a1,kk0a2
c
          do i=1,npts
            spect1(1,i)=zero
            spect1(2,i)=zero
          enddo
c
c         if (kk0a1.eq.0.and.kk0a2.eq.0) then
c           jk2mn=1
c           jk2sp=1
c         else
c           jk2mn=-1
c           jk2sp=-2
c         endif
c  
c         do jk2 = 1,jk2mn,jk2sp
          do jk2 = 1,1

            write(luttyo,1040)
            write(lulog,1040)
c
            call matr2k(ierr,jk2,kk0a1,kk0a2,ii)
c
c           if (ierr.eq.0) then
c             write (luttyo,1050) ndim,nelre,nelim,neltot,cpu1
c             write (lulog,1050) ndim,nelre,nelim,neltot,cpu1
c           else
c             write (luttyo,1070) cpu1
c             write (lulog,1070) cpu1
c             if (ierr.eq.1) then
c               write (luttyo,1080) mxel
c               write (lulog,1080) mxel
c             else if (ierr.eq.2) then
c               write (luttyo,1090) mxdim
c               write (lulog,1090) mxdim
c             end if
c             go to 110
c           end if
c
c---------------------------------------------------------------------
c     starting vector calculation
c---------------------------------------------------------------------
c
            write (luttyo,2000)
            write (lulog,2000)
c
            do 40 i=1,mxdim
              y(1,i)=zero
              y(2,i)=zero
 40         continue
c
            do i=1,ndim         
              if (zdiag(1,i).gt.rndoff) write (*,*) i,zdiag(1,i)
            enddo
c
            call stvect(x)
            do i=1,ndim  
c             if (x(1,i).lt.rndoff*1.0D8) x(1,i)=0.0D0
c             if (x(1,i).gt.rndoff) write(*,*) 'stvect0=',i,x(1,i)
            enddo
c
            call scmvmd(x,y,ndim,1)
c
            nelv=0
c
            vnorm=zero
            do 45 i=1,ndim
              vnorm=vnorm+y(1,i)*y(1,i)
              x(1,i)=y(1,i)
              x(2,i)=y(2,i)
              y(1,i)=zero
              y(2,i)=zero
              if (abs(x(1,i)).gt.rndoff*100) nelv=nelv+1
 45         continue
c
            vnorm=one/dsqrt(vnorm)
            write(*,*) 'vnorm=',vnorm
            do i=1,ndim
              x(1,i)=x(1,i)*vnorm
c             if (x(1,i).gt.rndoff) write(*,*) 'stvect=',i,x(1,i)
            enddo
c
            do i=ndim+1,mxdim
              x(1,i)=zero
              x(2,i)=zero
              y(1,i)=zero
              y(2,i)=zero
            enddo
c
c........................................
c Timing call specific to UNIX systems
c       cpu2 = dtime( tarray )
c........................................
c
            write (luttyo,2010) nelv,cpu2
            write (lulog,2010) nelv,cpu2
c
c----------------------------------------------------------------------
c     remove comments to store starting vector
c----------------------------------------------------------------------
c
            if (stvflg) then
              open (unit=ludisk,file=vtname(:namlth),status='unknown',
     #              access='sequential',form='unformatted')
              rewind (unit=ludisk)
              write (ludisk) (x(1,i),x(2,i),i=1,ndim)
              close (unit=ludisk)
            end if
c
c---------------------------------------------------------------------
c     create matrix
c---------------------------------------------------------------------
c
            write(luttyo,1040)
     	    write(lulog,1040) 
c
            call matrsr(ierr,jk2)
c
c........................................
c Timing call specific to UNIX systems
c           cpu1 = dtime( tarray )
c........................................
c
c           if (ierr.eq.0) then
c             write (luttyo,1050) ndim,nelre,nelim,neltot,cpu1
c             write (lulog,1050) ndim,nelre,nelim,neltot,cpu1
c           else 
c             write (luttyo,1070) cpu1
c             write (lulog,1070) cpu1
c             if (ierr.eq.1) then
c               write (luttyo,1080) mxel
c               write (lulog,1080) mxel
c             else if (ierr.eq.2) then
c               write (luttyo,1090) mxdim
c               write (lulog,1090) mxdim
c             end if
c             go to 110
c           end if
c
c----------------------------------------------------------------------
c     Output matrix if desired
c----------------------------------------------------------------------
c
            if (stmflg) then
              open (unit=ludisk,file=mtname(:namlth),status='unknown',
     #              access='sequential',form='unformatted')
              rewind (unit=ludisk)
              write (luttyo,4000) mtname(:namlth)
              write (ludisk) (zdiag(1,i),zdiag(2,i),i=1,ndim)
              write (ludisk) (jzmat(i),i=1,ndim+1)
              write (ludisk) (izmat(i),zmat(i),i=1,nelim)
              write (ludisk) (kzmat(i),i=1,ndim+1)
              write (ludisk) (izmat(mxel-i+1),zmat(mxel-i+1),i=1,nelre)
              close (unit=ludisk)
            end if
c
c           do i=1,ndim         
c             write (*,*) zdiag(1,i),zdiag(2,i)
c           enddo
c
c---------------------------------------------------------------------
c     call conjugate gradients routine
c---------------------------------------------------------------------
c
            write (luttyo,3000) 
            write (lulog,3000) 
c
c           do i=1,ndim
c             if (x(1,i).gt.rndoff) write(*,*) 'stvect=',i,x(1,i)
c           enddo
c
            call cscg(x,ndim,nstep,cgtol,dcmplx(shiftr,shifti),
     #                y,alpha,beta,ndone,error)
c
c           do j=1,nstep
c             write(*,*) alpha(1,j),alpha(2,j),beta(1,j),beta(2,j)
c           enddo
c
c........................................
c Timing call specific to UNIX systems
c           cpu3 = dtime( tarray )
c........................................
c
            if (ndone.gt.0) then
              write(luttyo,3010) ndone,error,cpu3
              write(lulog,3010) ndone,error,cpu3
            else
              write(luttyo,3020) nstep,-ndone,cgtol,error,cpu3
              write(lulog,3020) nstep,-ndone,cgtol,error,cpu3
            end if
c
c----------------------------------------------------------------------
c     set nstep equal to the number of CG steps done
c----------------------------------------------------------------------
c
            nstepl=abs(ndone)
c
c---------------------------------------------------------------------
c     update parameter file
c---------------------------------------------------------------------
c
            write (luttyo,4000) prname(:namlth)
            write (lulog,4000) prname(:namlth)
c
            call wrdat(prname,namlth)
c
c---------------------------------------------------------------------
c     store tridiagonal matrix
c---------------------------------------------------------------------
c
            write (luttyo,4000) tdname(:namlth)
            write (lulog,4000) tdname(:namlth)
c
            open (unit=ludisk,file=tdname,status='unknown',
     #            access='sequential',form='unformatted')
            rewind (unit=ludisk)
            write(ludisk) (alpha(1,j),alpha(2,j),beta(1,j),beta(2,j),
     #           j=1,nstep)
            close (unit=ludisk)
c
c           do j=1,nstep
c             write(*,*) alpha(1,j),alpha(2,j),beta(1,j),beta(2,j)
c           enddo
c----------------------------------------------------------------------
c       Diagonalize tridiagonal matrix
c----------------------------------------------------------------------
c
            isort=2
            ndiag=nstep
c
            do i=1,ndiag
              temp1(1,i)=alpha(1,i)
              temp1(2,i)=alpha(2,i)
              temp2(1,i)=beta(1,i)
              temp2(2,i)=beta(2,i)
            enddo
c
c           temp2(1,ndiag)=zero
c           temp2(2,ndiag)=zero
c
            call cmtqli(ndiag,temp1,temp2,w,ierr,isort)
c
            if (ierr.ne.0) write(luttyo,1140) ierr
c
            do i=1,ndiag
              tr=w(1,i)
              ti=w(2,i)
              w(1,i)=tr*tr-ti*ti
              if (abs(w(1,i)).lt.rndoff) w(1,i)=zero
              w(2,i)=two*tr*ti
              if (abs(w(2,i)).lt.rndoff) w(2,i)=zero
c             w(1,i)=dsqrt(w(1,i))
            enddo 
c
c     *** Output the eigenvalues
c
            open (unit=ludisk,file=egname(:namlth),status='unknown',
     #            access='sequential',form='formatted')
            write (ludisk,1130) (dble(i),temp1(1,i),temp1(2,i),
     #            w(1,i),w(2,i),i=1,ndiag)
c
c----------------------------------------------------------------------
c       Initialize field array and calculate spectral density
c----------------------------------------------------------------------
c
            npts=512
c           nstepl=nstep
            ideriv=0
c
            db=(bfn-bin)/dble(npts-1)
            bsweep=bin
            do 80 i=1,npts
              spect0(1,i)=zero
              spect0(2,i)=zero
              field(i)=bsweep
              bsweep=bsweep+db
 80         continue
c 
            sd1=vnorm*vnorm
c           if (kk0a1.eq.0.and.kk0a2.eq.0) then
              sd1=1.0D0/sd1
c           else
c             sd1=jk2*0.25D0/sd1
c           endif
c
c           write(4,*) 'normalization constant= ',sd1
c
            do i=1,npts
              spect0(1,i)=0.0D0
              sd3=field(i)*field(i)
              do j=1,nstep
                if (temp1(1,j).gt.rndoff) then 
                  sd2=sd3+temp1(1,j)*temp1(1,j)
                  spect0(1,i)=spect0(1,i)+w(1,j)*temp1(1,j)/sd2
                endif
              enddo
c
              spect1(1,i)=spect1(1,i)+spect0(1,i)*sd1
c
            enddo
c
          enddo
c
          do i=1,npts
            spect(1,i)=spect(1,i)+spect1(1,i)*ckk0(ii)
c           if (abs(spect(1,i)).lt.rndoff) spect(1,i)=0.0D0
c    #                 /vnorm(ii)/vnorm(ii)
c           spect(1,i)=spect(1,i)+spect1(1,i)
          enddo
c
c--------end loop over kk0----------------------
c
        enddo
c
c----------------------------------------------------------------------
c       Calculate spectral density using model free approach
c----------------------------------------------------------------------
c
        c(3)=0.0D0
        c(4)=0.0D0
        c(5)=0.0D0
c
        ict=0
        ii=10
        rndoff1=rndoff*1.0D16 
        write(*,*) rndoff1
        mxc20=10*ii
        mxc22=5*ii
        istep=1
        do i=0,mxc20,istep
        do j=-mxc22,mxc22,istep
          ict=ict+1
          c(1)=dble(i)/dble(ii)
          c(2)=dble(j)/dble(ii)
c
          call order(c,s)
c
          spect0(1,ict)=c(1)
          spect0(2,ict)=c(2)
          spect1(1,ict)=s(1)
          spect1(2,ict)=s(2)
c         write(*,*) i,j,spect0(1,ict),spect0(2,ict),
c    #               spect1(1,ict),spect1(2,ict)  
         end do
         end do
         nct=ict
         write(*,*) 'nct=',nct
c
         ict=0
         do i=1,nct-1
         do j=i+1,nct
           sd1=abs(spect1(1,i)-spect1(1,j))
           sd2=abs(spect1(2,i)-spect1(2,j))
           if (sd1.lt.rndoff1.and.sd2.lt.rndoff1) then
             ict=ict+1
c            write(*,*) i,j,sd1,sd2
c            write(*,*) i,j,spect1(1,i),spect1(1,j)
           endif
         enddo
         enddo
         write(*,*) 'ict=',ict  
c    
        do i=1,npts
          sd3=field(i)*field(i)
c         spect(2,i)=0.2D0*(sd1/(one+sd3*taum*taum)+
          spect(2,i)=(sd1/(one+sd3*taum*taum)+
     #                      sd2/(one+sd3*tauc*tauc))
        enddo
c
c----------------------------------------------------------------------
c     write spectrum to disk
c----------------------------------------------------------------------
c
          open (unit=ludisk,file=spname(:namlth),status='unknown',
     #         form='formatted')
          write (ludisk,7100)(field(i),spect(1,i),
     #                        spect(2,i),i=1,npts)
          close (unit=ludisk)
c
c----------------------------------------------------------------------
c       End of loop over input files
c----------------------------------------------------------------------
 110	continue
c
c---------------------------------------------------------------------
c     print out trailer and close log file
c---------------------------------------------------------------------
c
	write (luttyo,1000)
	write (lulog,1000)
c
	close (unit=lulog)
c
c======================================================================
c     end of loop over calculations
c======================================================================
c
c       cputot=cputot+cpu1+cpu2+cpu3
c
 100  continue
c
c---------------------------------------------------------------------
c     exit program
c---------------------------------------------------------------------
c
c9999 write (luttyo,6000) cputot
 
 9999  stop
c
c=====================================================================
c     format statements
c=====================================================================
c
 1000 format(//,2x,70('#'),//)
 1010 format(25x,'PROGRAM : EPRCGS',/,25x,'----------------',//)
c
 1040 format(/,15x,'*** Calculating matrix elements ***')
 1050 format(/,2x,'Dimension of the matrix : ',i6,
     #     /,2x,'Number of off-diagonal real elements: ',i8,
     #     /,2x,'Number of off-diagonal imaginary elements: ',i8,
     #     /,2x,'Total number of off-diagonal elements: ',i8,
     #     /,2x,'CPU time (seconds) : ',f10.2,/)
 1070 format(//,10x,
     #     '*** Serious error encountered in matrix generation ***'
     #     //20x,'CPU time (seconds) : ',f10.2,/)
 1080 format(/,10x,
     #  '*** Number of off-diagonal matrix elements exceeds ',i8,' ***')
 1090 format(/,20x,'*** Matrix dimension exceeds ',i6,' ***')
 1100 format(/,20x,'*** File ''',a,''' not found ***',/)
 1200 format(/,10x,'*** Error reading file ''',a,''' ***',/)
 1201 format(/,10x,'*** ''',a,''' is not an EPRSR Version 1.4 file',
     #' ***')
c
 2000 format(/,15x,'*** Calculating starting vector ***')
 2010 format(/,2x,'Number of non-zero elements in ',
     #            'starting vector : ',i5,
     #       /,2x,'CPU time (seconds) : ',f10.2)
c
 3000 format(/,15x,'*** Calculating tridiagonal matrix ***')
 3010 format(/,2x,'Number of CG steps executed : ',i3,
     #       /,2x,'Error in solution vector : ',g14.7,
     #       /,2x,'CPU time (seconds) : ',f10.2)
 3020 format(//,10x,'*** CG CALCULATION DID NOT CONVERGE ***'
     #     /,10x,'*** MAXIMUM NUMBER OF CG STEPS : ',i3,' ***',
     #     /,10x,'*** NUMBER OF CG STEPS EXECUTED : ',i3,' ***',
     #     /,10x,'*** MAXIMUM ERROR ALLOWED : ',g14.7,' ***',
     #     /,10x,'*** FINAL ERROR  : ',g14.7,' ***', 
     #     /,10x,'*** CPU TIME (SECONDS) : ',f10.2,' ***')
c
 4000 format(/,20x,'*** Writing ',a,' ***')
 5000 format(15x,38('='),/,
     #     15x,'Calculation no. ',I2,' using file ',a,/,
     #     15x,38('='),/)
 5100 format(//,10x,
     #     '*** ''',a,''' is not set to run EPRCGS (itype=1) ***')
c
 6000 format(/,2x,'Total CPU time (seconds) : ',f10.2)
c
 7100   format(3(g14.7,','))
c
 1130   format(5(g14.7,','))
 1140   format(//,10x,'*** ERROR IN DIAGONALIZATION, IERR=',i3,' ***')
c
c=====================================================================
c
      end
